//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TForm1::AddDefClick(TObject *Sender)
{
ListBox->Enabled = false;
AddBox->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
table->FieldDefs->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AddFieldClick(TObject *Sender)
{
TFieldDef* def = table->FieldDefs->AddFieldDef();
def->Name = FieldName->Text;
def->Size = FieldSize->Text.ToInt();
def->DataType = (TFieldType)FieldType->ItemIndex;
def->Attributes << (TFieldAttribute)((faHiddenCol&FieldHidden->Checked)|
                (faRequired&FieldRequired->Checked)|
                (faReadonly&FieldReadOnly->Checked)|
                (faFixed&FieldFixed->Checked));
Fields->Items->AddObject(FieldName->Text,def);
Fields->ItemIndex = Fields->Items->Count - 1;
CancelFieldClick(0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CancelFieldClick(TObject *Sender)
{
ListBox->Enabled = true;
AddBox->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
for(int i=0;i<Fields->Items->Count;i++)
        ((TFieldDef*)Fields->Items->Objects[i])->FieldNo = i;
table->TableType = (TTableType)TableType->ItemIndex;
table->TableName = TableName->Text;
table->CreateTable();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RemoveDefClick(TObject *Sender)
{
table->Active = false;
if(Fields->ItemIndex==-1)return;
TFieldDef* def = (TFieldDef*)Fields->Items->Objects[Fields->ItemIndex];
table->FieldDefs->Delete(def->Index);
Fields->DeleteSelected();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FieldsChange(TObject *Sender)
{
TFieldDef* def = (TFieldDef*)Fields->Items->Objects[Fields->ItemIndex];
FieldSize->Text = def->Size;
FieldType->ItemIndex = def->DataType;
FieldName->Text = def->Name;
FieldHidden->Checked = def->Attributes.Contains(faHiddenCol);
FieldRequired->Checked = def->Attributes.Contains(faRequired);
FieldReadOnly->Checked = def->Attributes.Contains(faReadonly);
FieldFixed->Checked = def->Attributes.Contains(faFixed);
}
//---------------------------------------------------------------------------

